class PromizeCart extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            canvasurl: '',
            minquantity: 1,
            maxquantity: 10000,
            quantitymultiples: 1,
            showEmailPopUp: false,
            editUrl: '',
            selectedValues: {},
            pzSettings: {
                1: 0, //zoom,
                2: 0, // full screen,
                3: 0, //undo redo,
                4: 0, //share
                5: 0, //save for later
                6: 0, //download
                7: 0, //add to cart
                8: 0, //start over
                9: 0, //quantity
                10: 0 //price
            },
            pzCartLoader: false
        }
    }
    pzDownloadHandler = (downloadinfo) => {
        console.log(downloadinfo)
        this.setState({ pzCartLoader: true });
        var download = document.getElementById('download');
        this.props.pzCanvas.discardActiveObject();
        this.props.pzCanvas.renderAll();
        var image = document.getElementById('pz_preview_image').toDataURL('image/png');
        if (this.props.pzDomainSettings[23] && downloadinfo) {
            let selectedObject = pzGetSelectedValuesForCart(this.props.pzCanvasObject, this.props.pzProductPrice, '', this.props.pzActiveOptions, this.props.pzCustomizer);
            if (selectedObject && selectedObject.imageProperty) {
                fetch(this.props.pzApiUrl + 'orderDownloadData', {
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json'
                    },
                    method: "POST",
                    body: JSON.stringify({ imgURL: image, imgProperties: JSON.stringify(selectedObject.imageProperty) })
                })
                    .then(res => res.json())
                    .then(response => {
                        let downloadImg = this.props.pzImgUrl + response.data.replace(this.props.pzReplaceImg, '');
                        this.download(downloadImg);
                    });
            } else {
                this.setState({ canvasurl: image, pzCartLoader: false }, () => {
                    download.click();
                })
            }
        } else {
            this.setState({ canvasurl: image, pzCartLoader: false }, () => {
                download.click();
            })
        }

    }

    toDataURL = (url) => {
        return fetch(url + "?" + new Date().getTime()).then((response) => {
            return response.blob();
        }).then(blob => {
            return URL.createObjectURL(blob);
        });
    }

    async download(url) {
        url = url.replace('//./', '/');
        const a = document.createElement("a");
        const min = 1;
        const max = 100;
        const rand = min + Math.random() * 100000 * (max - min);
        var ext = url.substr(url.lastIndexOf('.') + 1);
        a.href = await this.toDataURL(url);
        //a.href = url;
        //a.target = '_blank';
        a.download = "myImage_" + parseInt(rand) + "." + ext.split('?')[0];
        document.body.appendChild(a);
        a.click();
        document.body.removeChild(a);
        this.setState({ pzCartLoader: false });
    }


    pzShare = () => {
        let selectedValues = pzGetSelectedValues(this.props.pzCanvasObject, this.props.pzProductPrice, this.props.pzActiveOptions, this.props.pzCustomizer)
        pzSaveForLater(this.props).then((response) => {
            var editUrl = response;
            this.setState({ showEmailPopUp: true, editUrl: editUrl, selectedValues: selectedValues })
        })
    }
    pzStartOverHandler = () => {
        this.props.HomeComponent.setState({ pzPopup: true })

    }
    pzSocialMediaShare = () => {
        this.props.HomeComponent.setState({ pzSharePopup: true })
        var image = document.getElementById('pz_preview_image').toDataURL('image/png');
        // this.setState({ canvasimageurl: image });
        this.props.HomeComponent.setState({ canvasimageurl: image })
    }
    pzQuantityHandler = (e, value) => {
        e.preventDefault();
        let { pzProductPrice, pzQuantity } = this.props
        let price = pzQuantity ? parseFloat(pzProductPrice) / parseInt(pzQuantity) : parseFloat(pzProductPrice)
        pzProductPrice = value ? (parseFloat(price) * parseFloat(value)) : (parseInt(e.target.value) > 0 ? parseFloat(price) * parseInt(e.target.value) : parseFloat(price));
        this.props.HomeComponent.setState({ pzProductPrice, pzQuantity: value ? parseInt(value) : (parseInt(e.target.value) === 0 ? 1 : parseInt(e.target.value)) })
    }
    pzShopifyAddToCart = () => {
        console.log("this.state inside promize cart", this.props.HomeComponent);
        let { pzCanvasObject, pzCurrentView, pzCanvas } = this.props.HomeComponent.state;
        const fobject = pzCanvasObject[pzCurrentView];   
        console.log("fobject", fobject);    
        const layer_array1 = Object.values(fobject).filter(function (propertyName) {
            return propertyName.layerno == 1
        });
        console.log("layer_array1", layer_array1);
        if(layer_array1["0"].src)   {
            const layer_image = layer_array1["0"].src
            this.props.HomeComponent.setState({ canvasimageforlayer: layer_image })
        }
        // const img = document.querySelector('#layer_one_image');
        // console.log("img", img);
        // const layercanvas = document.createElement('canvas');
        // const ctx = layercanvas.getContext('2d');
        // // Set width and height
        // layercanvas.width = img.width;
        // layercanvas.height = img.height;
        // // Draw the image
        // ctx.drawImage(img, 0, 0);
        // const finalImage =  layercanvas.toDataURL('image/jpeg');
        // var image = new Image();
        // image.src = layer_image;
        // var layerCanvas = document.createElement("canvas");
        // var layerContext = layerCanvas.getContext("2d");

        // layerCanvas.height = "200";
        // layerCanvas.width = "200";

        // layerContext.drawImage(image, 0, 0, 200, 200);
        // var myResizedData = layerCanvas.toDataURL('image/png');
        // console.log("myResizedData inside cart", myResizedData);
        // var image2 = new Image();
        // image2.src = myResizedData
        // console.log("image2", image2);
        pzCanvas.discardActiveObject().renderAll();
        this.props.HomeComponent.setState({ pzCartPopup: true })
        var image = document.getElementById('pz_preview_image').toDataURL('image/png');
        this.props.HomeComponent.setState({ canvasimageurlforcart: image })
    }

    render() {
        return (
            <React.Fragment>
                <PZCart {...this.props} {...this.state} IncrementItem={this.IncrementItem} DecreaseItem={this.DecreaseItem} pzDownloadHandler={this.pzDownloadHandler} pzStartOverHandler={this.pzStartOverHandler} pzQuantityHandler={this.pzQuantityHandler} canvasurl={this.state.canvasurl} pzShare={this.pzShare} pzSocialMediaShare={this.pzSocialMediaShare} pzAddToCart={this.pzShopifyAddToCart} />
                {this.state.showEmailPopUp && <PromizeMailShare {...this.props} {...this.state} cart={this} />}
            </React.Fragment>
        );
    }
}
